searchNodes=[{"doc":"Helpers for common operations around EVM networks.","ref":"ExWeb3.html","title":"ExWeb3","type":"module"},{"doc":"Similar to :binary.decode_unsigned/1 , except we decode &lt;&lt;&gt;&gt; back to 0 , which is a common practice in Ethereum, since we cannot have any leading zeros. Examples iex&gt; ExWeb3 . decode_unsigned ( &lt;&lt; &gt;&gt; ) 0 iex&gt; ExWeb3 . decode_unsigned ( &lt;&lt; 5 &gt;&gt; ) 5 iex&gt; ExWeb3 . decode_unsigned ( &lt;&lt; 76 , 75 , 64 &gt;&gt; ) 5_000_000","ref":"ExWeb3.html#decode_unsigned/1","title":"ExWeb3.decode_unsigned/1","type":"function"},{"doc":"Similar to :binary.encode_unsigned/1 , except we encode 0 as &lt;&lt;&gt;&gt; , the empty string. This is because the specification says that we cannot have any leading zeros, and so having &lt;&lt;0&gt;&gt; by itself is leading with a zero and prohibited. Examples iex&gt; ExWeb3 . encode_unsigned ( 0 ) &lt;&lt; &gt;&gt; iex&gt; ExWeb3 . encode_unsigned ( 5 ) &lt;&lt; 5 &gt;&gt; iex&gt; ExWeb3 . encode_unsigned ( 5_000_000 ) &lt;&lt; 76 , 75 , 64 &gt;&gt;","ref":"ExWeb3.html#encode_unsigned/1","title":"ExWeb3.encode_unsigned/1","type":"function"},{"doc":"Create digest for Ethereum signature for a generic binary data.","ref":"ExWeb3.html#eth_hash_message!/1","title":"ExWeb3.eth_hash_message!/1","type":"function"},{"doc":"Recovers a public key from a given signature structured as a hex string returned by ethers.js e.g: String . length ( &quot;0x&quot; &lt;&gt; signature &lt;&gt; recovery_id ) == 67","ref":"ExWeb3.html#eth_recover/2","title":"ExWeb3.eth_recover/2","type":"function"},{"doc":"","ref":"ExWeb3.html#eth_sign/2","title":"ExWeb3.eth_sign/2","type":"function"},{"doc":"Simple wrapper for decoding ABI encoded hex data.","ref":"ExWeb3.html#from_abi/1","title":"ExWeb3.from_abi/1","type":"function"},{"doc":"Simple wrapper for decoding hex data. Examples iex&gt; ExWeb3 . from_hex ( &quot;aabbcc&quot; ) &lt;&lt; 0xaa , 0xbb , 0xcc &gt;&gt;","ref":"ExWeb3.html#from_hex/1","title":"ExWeb3.from_hex/1","type":"function"},{"doc":"Simple wrapper for decoding hex data. Examples iex&gt; ExWeb3 . from_prefixed_hex ( &quot;0xaabbcc&quot; ) { :ok , &lt;&lt; 0xaa , 0xbb , 0xcc &gt;&gt; }","ref":"ExWeb3.html#from_prefixed_hex/1","title":"ExWeb3.from_prefixed_hex/1","type":"function"},{"doc":"Simple wrapper for decoding hex data. Examples iex&gt; ExWeb3 . from_prefixed_hex! ( &quot;0xaabbcc&quot; ) &lt;&lt; 0xaa , 0xbb , 0xcc &gt;&gt;","ref":"ExWeb3.html#from_prefixed_hex!/1","title":"ExWeb3.from_prefixed_hex!/1","type":"function"},{"doc":"Generate random expirable challenge for signature.","ref":"ExWeb3.html#gen_eth_challenge/2","title":"ExWeb3.gen_eth_challenge/2","type":"function"},{"doc":"Get Ethereum address from private or public key.","ref":"ExWeb3.html#get_address/1","title":"ExWeb3.get_address/1","type":"function"},{"doc":"Get public key from private key.","ref":"ExWeb3.html#get_public_key/1","title":"ExWeb3.get_public_key/1","type":"function"},{"doc":"Convert hex encoded string to integer. Examples iex&gt; ExWeb3 . hex_to_int! ( &quot;0x1&quot; ) 1 iex&gt; ExWeb3 . hex_to_int! ( &quot;0xA&quot; ) 10","ref":"ExWeb3.html#hex_to_int!/1","title":"ExWeb3.hex_to_int!/1","type":"function"},{"doc":"Check if Ethereum login challenge has expired.","ref":"ExWeb3.html#is_eth_signed_challenge_expired?/1","title":"ExWeb3.is_eth_signed_challenge_expired?/1","type":"function"},{"doc":"Validate if Ethereum challenge digest was signed with a proper wallet.","ref":"ExWeb3.html#is_eth_signed_challenge_valid?/3","title":"ExWeb3.is_eth_signed_challenge_valid?/3","type":"function"},{"doc":"Returns the keccak sha256 of a given input. Examples iex&gt; ExWeb3 . kec ( &quot;hello world&quot; ) &lt;&lt; 71 , 23 , 50 , 133 , 168 , 215 , 52 , 30 , 94 , 151 , 47 , 198 , 119 , 40 , 99 , 132 , 248 , 2 , 248 , 239 , 66 , 165 , 236 , 95 , 3 , 187 , 250 , 37 , 76 , 176 , 31 , 173 &gt;&gt; iex&gt; ExWeb3 . kec ( &lt;&lt; 0x01 , 0x02 , 0x03 &gt;&gt; ) &lt;&lt; 241 , 136 , 94 , 218 , 84 , 183 , 160 , 83 , 49 , 140 , 212 , 30 , 32 , 147 , 34 , 13 , 171 , 21 , 214 , 83 , 129 , 177 , 21 , 122 , 54 , 51 , 168 , 59 , 253 , 92 , 146 , 57 &gt;&gt;","ref":"ExWeb3.html#kec/1","title":"ExWeb3.kec/1","type":"function"},{"doc":"Simply returns the rightmost n bits of a binary. Examples iex&gt; ExWeb3 . mask ( 0b111101111 , 6 ) 0b101111 iex&gt; ExWeb3 . mask ( 0b101101 , 3 ) 0b101 iex&gt; ExWeb3 . mask ( 0b011 , 1 ) 1 iex&gt; ExWeb3 . mask ( 0b011 , 0 ) 0 iex&gt; ExWeb3 . mask ( 0b010 , 1 ) 0 iex&gt; ExWeb3 . mask ( 0b010 , 20 ) 0b010","ref":"ExWeb3.html#mask/2","title":"ExWeb3.mask/2","type":"function"},{"doc":"Simply returns the rightmost n bits of a binary. Examples iex&gt; ExWeb3 . mask_bitstring ( &lt;&lt; 0b111101111 &gt;&gt; , 6 ) &lt;&lt; 0b101111 :: size ( 6 ) &gt;&gt; iex&gt; ExWeb3 . mask_bitstring ( &lt;&lt; 0b101101 &gt;&gt; , 3 ) &lt;&lt; 0b101 :: size ( 3 ) &gt;&gt; iex&gt; ExWeb3 . mask_bitstring ( &lt;&lt; 0b011 &gt;&gt; , 1 ) &lt;&lt; 1 :: size ( 1 ) &gt;&gt; iex&gt; ExWeb3 . mask_bitstring ( &lt;&lt; 0b011 &gt;&gt; , 0 ) &lt;&lt; &gt;&gt; iex&gt; ExWeb3 . mask_bitstring ( &lt;&lt; 0b010 &gt;&gt; , 1 ) &lt;&lt; 0 :: size ( 1 ) &gt;&gt; iex&gt; ExWeb3 . mask_bitstring ( &lt;&lt; 0b010 &gt;&gt; , 20 ) &lt;&lt; 0 , 0 , 2 :: size ( 4 ) &gt;&gt; iex&gt; ExWeb3 . mask_bitstring ( &lt;&lt; 0b010 &gt;&gt; , 3 ) &lt;&lt; 0b010 :: size ( 3 ) &gt;&gt; iex&gt; ExWeb3 . mask_bitstring ( &lt;&lt; &gt;&gt; , 3 ) &lt;&lt; 0b000 :: size ( 3 ) &gt;&gt;","ref":"ExWeb3.html#mask_bitstring/2","title":"ExWeb3.mask_bitstring/2","type":"function"},{"doc":"Returned a binary padded to given length in bytes. Fails if binary is longer than desired length. Examples iex&gt; ExWeb3 . pad ( &lt;&lt; 9 &gt;&gt; , 5 ) &lt;&lt; 0 , 0 , 0 , 0 , 9 &gt;&gt; iex&gt; ExWeb3 . pad ( &lt;&lt; 9 &gt;&gt; , 1 ) &lt;&lt; 9 &gt;&gt; iex&gt; ExWeb3 . pad ( &lt;&lt; 9 , 9 &gt;&gt; , 1 ) ** (RuntimeError) Binary too long for padding","ref":"ExWeb3.html#pad/2","title":"ExWeb3.pad/2","type":"function"},{"doc":"Recovers a public key from a given signature for a given digest. Note, the key is returned in DER format (with a leading 0x04 to indicate that it's an octet-string).","ref":"ExWeb3.html#recover/3","title":"ExWeb3.recover/3","type":"function"},{"doc":"Signs message with private key, returns signature parts {r, s, v}","ref":"ExWeb3.html#sign/2","title":"ExWeb3.sign/2","type":"function"},{"doc":"Simple wrapper to generate hex. Examples iex&gt; ExWeb3 . to_hex ( &lt;&lt; 0xaa , 0xbb , 0xcc &gt;&gt; ) &quot;aabbcc&quot;","ref":"ExWeb3.html#to_hex/1","title":"ExWeb3.to_hex/1","type":"function"},{"doc":"Encoder from binary to hex data. Examples iex&gt; ExWeb3 . to_prefixed_hex ( &lt;&lt; 0xaa , 0xbb , 0xcc &gt;&gt; ) &quot;0xaabbcc&quot;","ref":"ExWeb3.html#to_prefixed_hex/1","title":"ExWeb3.to_prefixed_hex/1","type":"function"},{"doc":"Verifies a that a given signature for a given digest is valid against a public key.","ref":"ExWeb3.html#verify/3","title":"ExWeb3.verify/3","type":"function"},{"doc":"","ref":"ExWeb3.html#t:keccak_hash/0","title":"ExWeb3.keccak_hash/0","type":"type"},{"doc":"Helpers and utility functions to work with keccak256, secp256k1 and other low-level primitives used on EVM-compatiable networks, like: Ethereum, Polygon, Binance Smart Chain etc. For API documentations, check hex . ExWeb3 can be easily integrated with Phoenix and Guardian to authenticate requests signed by EVM-compatiable wallet like Metamask with the help of ExWeb3.Guardian.Plug.VerifySignature and ExWeb3.Phoenix.Plug.SaveRawBody plugs. Just add plug ExWeb3.Phoenix.Plug.SaveRawBody, match_req_path: ~r[^(.*)$] to endpoint.ex before plug Plug.Parsers to allow signature authentication for all routes, then you can use Guardian plug in router pipelines normally: plug ExWeb3.Guardian.Plug.VerifySignature , resource_by_pub_key : &amp; Filters . fetch_by_pub_key / 1 , claims_for_resource : &amp; ( MyApp.ImplementationModule . build_claims ( %{ } , &amp;1 ) )","ref":"readme.html","title":"ExWeb3","type":"extras"},{"doc":"Add ex_web3 to your list of dependencies in mix.exs : def deps do [ { :ex_web3 , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"ExWeb3 - Installation","type":"extras"}]